/**
 * 
 */
package com.primeton.dsp.datarelease.api.model;

import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * @author zhaopx
 *
 */
public class JoinPair {
	
	
	/**
	 * left table
	 */
	String left;


	/**
	 * 左边表关联的字段
	 */
	String leftField;
	
	/**
	 * join type: inner_join,left_join,right_join, full_out_join;
	 */
	String joinType;


	/**
	 * 运算逻辑: =（等于），正常的JOIN都是等于。其他奇葩的 >（大于），<（小于），>=（大于或等于），<=（小于或等于）,<> or !=（不等于）也理论支持。
	 */
	String opera = "=";
	
	/**
	 * right table
	 */
	String right;


	/**
	 * 右边表关联的字段
	 */
	String rightField;
	

	/**
	 * 
	 */
	public JoinPair() {
		
	}


	public JoinPair(String left, String joinType, String right) {
		super();
		this.left = left;
		this.joinType = joinType;
		this.right = right;
	}

	public JoinPair(String left, String leftField, String joinType, String right, String rightField) {
		this.left = left;
		this.leftField = leftField;
		this.joinType = joinType;
		this.right = right;
		this.rightField = rightField;
	}

	public String getLeft() {
		return left;
	}


	public String getRight() {
		return right;
	}

	
	

	public String getJoinType() {
		return joinType;
	}


	public void setJoinType(String joinType) {
		this.joinType = joinType;
	}


	public String getOpera() {
		return opera;
	}

	public void setOpera(String opera) {
		this.opera = opera;
	}

	public void setLeft(String left) {
		this.left = left;
	}


	public void setRight(String right) {
		this.right = right;
	}


	public String getLeftField() {
		return leftField;
	}

	public void setLeftField(String leftField) {
		this.leftField = leftField;
	}

	public String getRightField() {
		return rightField;
	}

	public void setRightField(String rightField) {
		this.rightField = rightField;
	}

	@Override
	public String toString(){
		return ToStringBuilder.reflectionToString(this);
	}

}
