package com.primeton.dsp.datarelease.data.bdata;

import java.io.File;

/**
 *
 * Hive Hbase 租户认证信息
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2020/4/20
 * Time: 10:52
 *
 * </pre>
 *
 * @author zhaopx
 */
public  abstract class AuthPrincipal {


    /**
     * 返回租户名称
     * @return
     */
    public abstract String getPrincipal();

    /**
     * 返回租户描述
     * @return
     */
    public abstract String getPrincipalDesc();

    /**
     * 返回用户 user keytab 文件地址
     * @return
     */
    public abstract File getUserKeytabFile();


    /**
     * 返回用户 user krb5 文件地址
     * @return
     */
    public abstract File getKrb5File();


    /**
     * 返回用户 user hive client 文件地址, FI 特有
     * @return
     */
    public abstract File getHiveClientFile();


    public abstract File getCoreSite();


    public abstract File getHdfsSite();


    public abstract File getHiveSite();


    public abstract File getHBaseSite();
}
