package com.primeton.damp.core.config;

import lombok.Getter;
import lombok.Setter;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

/**
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2021/4/2
 * Time: 16:01
 *
 * </pre>
 *
 * @author zhaopx
 */
@Configuration
@ConfigurationProperties(prefix = "hadoop")
@Getter
@Setter
public class HadoopProperties {


    /**
     * hdfs 文件类型， cluster、local  用 localFile FS 模拟 HDFS
     */
    String hdfsType = "local";


    /**
     * 认证的租户名称
     */
    String tenentName;


    /**
     * hdfs coreSite
     */
    String coreSite;

    /**
     * hdfs Site
     */
    String hdfsSite;

    /**
     * user keytab
     */
    String userKeytab;

    /**
     * kerberos
     */
    String krb5File;
}
