package com.primeton.dgs.kernel.core.cache;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 *
 * 缓存删除策略
 *
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2019/11/8
 * Time: 17:45
 *
 * </pre>
 *
 * @author zhaopx
 */
@Inherited
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface CacheEvict {

    /**
     *
     * 精确的删除缓存的 key， 一次性删除多个。
     *
     * 缓存的key，支持 ${var} 获取变量
     */
    String[] keys() default {};

    /**
     * 触发条件，只有满足条件的情况才会清除缓存
     * 根据前缀，模糊删除
     * @return
     */
    String keyPrefix() default "";

    /**
     * true表示清除value中的全部缓存，默认为false
     *
     * @return
     */
    boolean allEntries() default false;
}
