package com.primeton.dgs.kernel.core.message;

/**
 *
 * 发行消息，发送总是单例模式进行的。
 *
 * @see {@link MessageService#getMessageProvider()} 获得消息发送提供者
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2019/11/11
 * Time: 13:53
 *
 * </pre>
 *
 * @author zhaopx
 */
public interface MessageProvider {


    /**
     * 发送消息
     * @param topic
     * @param message
     */
    public void send(String topic, Object message);


    /**
     * 发送消息
     * @param event 消息实体
     */
    public void send(Event<Object> event);

}
