package com.primeton.filetransfer.server.template;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * JDBC ResultSet 转 Map Object 快捷方法
 *
 * <pre>
 *
 * Created by zhaopx.
 * User: zhaopx
 * Date: 2022/3/7
 * Time: 下午4:04
 * Vendor: primeton.com
 *
 * </pre>
 *
 * @author zhaopx
 */
public class MapResultTransformer implements ResultTransformer<Map<String, Object>> {

    @Override
    public Map<String, Object> transformTuple(Object[] tuple, String[] aliases) {
        Map<String, Object> result = new HashMap(tuple.length);
        for ( int i=0; i<tuple.length; i++ ) {
            String alias = aliases[i];
            if ( alias!=null ) {
                result.put( alias, tuple[i] );
            }
        }
        return result;
    }
}
